@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo. Error^^! Please do not execute this file alone^^! && echo. && echo. Please press any key to exit. && pause>nul && exit

:getFastbootdPT
    REM vers
    set devicePTFile=%~dp0devicePT_%serial_number%.txt
    set device_ab_slot=0
    REM remove temp file

    del /f /s /q "%devicePTFile%" >nul 2>nul
    if %errorlevel% NEQ 0 (
        color fc
        echo.
        echo. A fatal error occurred, exiting...
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )
    REM is device support A/B partition?
    set device_slot_count=0
    set device_current_slot=
    for /F "usebackq tokens=*" %%X in (`%fastboot% -s %serial_number% getvar slot-count 2^>^&1 ^>nul`) do (
        for /F "tokens=2 delims== " %%C in ('echo %%X ^| %grep% "slot-count:"') do (
            set device_slot_count=%%C
        )
    )
    for /F "usebackq tokens=*" %%X in (`%fastboot% -s %serial_number% getvar current-slot 2^>^&1 ^>nul`) do (
        for /F "tokens=2 delims== " %%C in ('echo %%X ^| %grep% "current-slot:"') do (
            set device_current_slot=%%C
        )
    )

    if "%device_slot_count%" NEQ "" (
        if "!device_slot_count!" EQU "2" (
            set device_ab_slot=1
            echo.
            echo. [Debug] Device [%serial_number%] has slot A/B partition.
        ) else (
            set device_ab_slot=0
            echo.
            echo. [Debug] Device [%serial_number%] does not have slot A/B partition.
        )
    ) else (
        echo.
        echo. [Debug] Device slot info is unknown.
        set device_ab_slot=0
    )

    set slotsuffix=
    if "%device_ab_slot%" EQU "0" (
        set slotsuffix=
    )
    if "%device_ab_slot%" EQU "1" (
        set slotsuffix=_!device_current_slot!
        REM If there are multiple _, use the last two characters
        if "!slotsuffix:~0,2!" EQU "__" (
            set slotsuffix=!slotsuffix:~-2!
        )
        echo. [Debug] Device [!serial_number!] current slot: [!slotsuffix!]
    )

    %fastboot% -s %serial_number% getvar all 2>"%devicePTFile%"

    set system_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "has-slot:system" ^| %awk% -F: "{print $3}"') do (
        set system_tmp=%%C
    )
    set vendor_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "has-slot:vendor" ^| %awk% -F: "{print $3}"') do (
        set vendor_tmp=%%C
    )
    set product_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "has-slot:product" ^| %awk% -F: "{print $3}"') do (
        set product_tmp=%%C
    )

    set device_has_system=0
    if "%system_tmp%" EQU "yes" (
        set device_has_system=1
    ) else (
        set device_has_system=0
    )
    set device_has_vendor=0
    if "%vendor_tmp%" EQU "yes" (
        set device_has_vendor=1
    ) else (
        set device_has_vendor=0
    )
    set device_has_product=0
    if "%product_tmp%" EQU "yes" (
        set device_has_product=1
    ) else (
        set device_has_product=0
    )

    REM remove temp file
    del /f /s /q "%devicePTFile%" >nul 2>nul
    if %errorlevel% NEQ 0 (
        color fc
        echo.
        echo. A fatal error occurred, exiting...
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )
exit /b 0
::
::
:exit
exit
